/*
  LiquidCrystal Library - Hello World


LIGAÇÃO DO LCD 
 * LCD RS pin to digital pin 8
 * LCD Enable pin to digital pin 9
 * LCD D4 pin to digital pin 4
 * LCD D5 pin to digital pin 5
 * LCD D6 pin to digital pin 6
 * LCD D7 pin to digital pin 7
 * LCD R/W pin to ground
 * 10K resistor:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)

 This example code is in the public domain.
 by Tom Igoe
 http://www.arduino.cc/en/Tutorial/LiquidCrystal
 
  Nossa LOJA: 
  http://www.androidarduino.com.br 
  http://www.zuchishop.com.br
  http://www.zuchi.com.br
  
 CONHEÇA NOSSOS PRODUTOS, LANÇAMENTOS SEMANAIS, PROMOÇÕES E TUTORIAIS 

 */

// O exemplo desenvolvido é baseado na biblioteca padrão do Arduino "LiquidCrystal Library". 
// AS CHAVES SÃO IDENTIFICADAS ATRAVES DO CONVERSOR ANALÓGICO DIGITAL. A CONEXÃO DAS CHAVES É EXECUTADA ATRAVES 
// DE UM DIVISOR RESISTIVO. 


// include the library code:
#include <LiquidCrystal.h>


//CONFIGURAÇÃO 
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
//Key message
char msgs[5][15] = {"Right Key OK ",
                    "Up Key OK    ",
                    "Down Key OK  ",
                    "Left Key OK  ",
                    "Select Key OK" };
int  adc_key_val[5] ={30, 150, 360, 535, 760 };
int NUM_KEYS = 5;
int adc_key_in;
int key=-1;
int oldkey=-1;



void setup() {
  Serial.begin(9600);
  Serial.println("BLUETOOTH CONTROL ZUCHI SHOP");   
  lcd.begin(16, 2);  // CONFIGURA O DISPLAY COM 16 POSIÇÕES 2 
  lcd.print("OLA!ZUCHISHOP"); //IMPRIME OLA NO DISPLAY 
  pinMode(10,OUTPUT); // COFIGURA O  O BACKLIGHT DO DISPLAY 
  digitalWrite(10,LOW);  //ATIVA O BACKLIGHT DO DISPLAY
}

void loop() {
  adc_key_in = analogRead(0);    // LÊ A TENSÃO DO DIVISOR RESISTIVO ( LEITURA DAS CHAVES ) 
  key = get_key(adc_key_in);    // CONVERTE A LEITURA DO CONVERSOR A/D PARA UMA CHAVE 
  if (key != oldkey)  // VERIFICA SE A CHAVE APERTADA É DIFERENTE DA CHAVE ANTERIOR 
  {
    delay(50);    // AGUARDA 50MS PARA GARANTIR QUE A CHAVE ESTA REALMENTE APERTADA ( TRATAMENTO DE BOUCING )
    adc_key_in = analogRead(0);   // LÊ A TENSÃO DO DIVISOR RESISTIVO ( LEITURA DAS CHAVES )
    key = get_key(adc_key_in);    // CONVERTE A LEITURA DO CONVERSOR A/D PARA UMA CHAVE 
    if (key != oldkey)            // SE A CHAVE FOI REALMENTE APERTADA E MANTIDO APERTADA 
    {
      oldkey = key;
      if (key >=0){
      lcd.setCursor(0, 1);  //line=2, x=0  //POSICIONA O CURSOR DO DISPLAY NA POSIÇÃO 0 DA SEGUNDA LINHA   
      lcd.print(msgs[key]); // IMPREME A MENSAGEM COM O CODIGO DA CHAVE APERTADA 
      Serial.println(msgs[key]); 
      
      }
    }
  }
  
  

  lcd.setCursor(13, 1); // IMPRIME NA POSIÇÃO 13 DA LINHA 0 UM CONTADOR DE TEMPO APÓS INICIALIZAÇÃO 
  lcd.print(millis()/1000);
}

// Convert ADC value to key number
int get_key(unsigned int input)
{
	int k;
    
	for (k = 0; k < NUM_KEYS; k++)
	{
		if (input < adc_key_val[k])
		{
           
    return k;
        }
	}
    
    if (k >= NUM_KEYS)
        k = -1;     // No valid key pressed
    
    return k;
}
